/* original parser id follows */
/* yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93" */
/* (use YYMAJOR/YYMINOR for ifdefs dependent on parser version) */

#define YYBYACC 1
#define YYMAJOR 2
#define YYMINOR 0
#define YYPATCH 20200910

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)
#define YYENOMEM       (-2)
#define YYEOF          0
#define YYPREFIX "yy"

#define YYPURE 0

#line 15 "../../lib/cgraph/grammar.y"

#include <stdio.h>  /* SAFE */
#include <cghdr.h>	/* SAFE */
extern void yyerror(char *);	/* gets mapped to aagerror, see below */

#ifdef _WIN32
#define gettxt(a,b)	(b)
#endif

static char Key[] = "key";
static int SubgraphDepth = 0;

typedef union s {					/* possible items in generic list */
		Agnode_t		*n;
		Agraph_t		*subg;
		Agedge_t		*e;
		Agsym_t			*asym;	/* bound attribute */
		char			*name;	/* unbound attribute */
		struct item_s	*list;	/* list-of-lists (for edgestmt) */
} val_t;

typedef struct item_s {		/* generic list */
	int				tag;	/* T_node, T_subgraph, T_edge, T_attr */
	val_t			u;		/* primary element */
	char			*str;	/* secondary value - port or attr value */
	struct item_s	*next;
} item;

typedef struct list_s {		/* maintain head and tail ptrs for fast append */
	item			*first;
	item			*last;
} list_t;

typedef struct gstack_s {
	Agraph_t *g;
	Agraph_t *subg;
	list_t	nodelist,edgelist,attrlist;
	struct gstack_s *down;
} gstack_t;

/* functions */
static void appendnode(char *name, char *port, char *sport);
static void attrstmt(int tkind, char *macroname);
static void startgraph(char *name, int directed, int strict);
static void getedgeitems(int x);
static void newedge(Agnode_t *t, char *tport, Agnode_t *h, char *hport, char *key);
static void edgerhs(Agnode_t *n, char *tport, item *hlist, char *key);
static void appendattr(char *name, char *value);
static void bindattrs(int kind);
static void applyattrs(void *obj);
static void endgraph(void);
static void endnode(void);
static void endedge(void);
static void freestack(void);
static char* concat(char*, char*);
static char* concatPort(char*, char*);

static void opensubg(char *name);
static void closesubg(void);

/* global */
static Agraph_t *G;				/* top level graph */
static	Agdisc_t	*Disc;		/* discipline passed to agread or agconcat */
static gstack_t *S;

#ifdef YYSTYPE
#undef  YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#endif
#ifndef YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#line 82 "../../lib/cgraph/grammar.y"
typedef union	{
			int				i;
			char			*str;
			struct Agnode_s	*n;
} YYSTYPE;
#endif /* !YYSTYPE_IS_DECLARED */
#line 100 "y.tab.c"

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
# ifdef YYPARSE_PARAM_TYPE
#  define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
# else
#  define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
# endif
#else
# define YYPARSE_DECL() yyparse(void)
#endif

/* Parameters sent to lex. */
#ifdef YYLEX_PARAM
# define YYLEX_DECL() yylex(void *YYLEX_PARAM)
# define YYLEX yylex(YYLEX_PARAM)
#else
# define YYLEX_DECL() yylex(void)
# define YYLEX yylex()
#endif

#if !(defined(yylex) || defined(YYSTATE))
int YYLEX_DECL();
#endif

/* Parameters sent to yyerror. */
#ifndef YYERROR_DECL
#define YYERROR_DECL() yyerror(const char *s)
#endif
#ifndef YYERROR_CALL
#define YYERROR_CALL(msg) yyerror(msg)
#endif

extern int YYPARSE_DECL();

#define T_graph 257
#define T_node 258
#define T_edge 259
#define T_digraph 260
#define T_subgraph 261
#define T_strict 262
#define T_edgeop 263
#define T_list 264
#define T_attr 265
#define T_atom 266
#define T_qatom 267
#define YYERRCODE 256
typedef short YYINT;
static const YYINT yylhs[] = {                           -1,
    0,    0,    0,   11,   10,    6,    6,    1,    1,    2,
    2,   12,   12,   13,   13,   15,   15,   14,   14,   17,
   18,   18,   22,   23,    3,    3,   20,   20,   24,   24,
   24,   16,   16,    4,    4,    4,    7,    7,   19,   19,
   25,   27,   27,   28,   29,   29,   31,   32,   26,   33,
   21,    5,    5,    5,   30,   30,   30,    8,    8,    9,
    9,
};
static const YYINT yylen[] = {                            2,
    2,    1,    0,    3,    3,    1,    0,    1,    0,    1,
    1,    1,    0,    2,    1,    1,    0,    2,    2,    3,
    1,    1,    0,    0,    5,    0,    1,    3,    1,    3,
    5,    3,    1,    1,    1,    1,    2,    0,    1,    0,
    4,    2,    0,    2,    1,    1,    3,    2,    1,    0,
    3,    2,    1,    0,    1,    1,    0,    1,    1,    1,
    3,
};
static const YYINT yydefred[] = {                         0,
    2,    8,    0,    0,    0,   10,   11,    0,    0,    1,
   58,   60,    5,    6,    0,   34,   35,   36,    0,    0,
   50,    0,    0,    0,   15,    0,    0,    0,    0,   22,
   27,   33,   49,    0,   52,   40,    0,    0,    0,    0,
    4,   14,   16,   18,   19,   23,   40,    0,   61,    0,
    0,   37,   51,    0,   47,    0,    0,   39,    0,   28,
   43,    0,   24,    0,   31,    0,   41,    0,    0,   42,
    0,   45,   46,   25,   48,   55,   56,   44,
};
static const YYINT yydgoto[] = {                          3,
    4,    8,   47,   20,   21,   13,   36,   22,   15,    5,
   10,   23,   24,   25,   44,   26,   27,   28,   50,   29,
   30,   56,   66,   31,   51,   32,   64,   70,   71,   78,
   33,   73,   38,
};
static const YYINT yysindex[] = {                      -227,
    0,    0,    0, -241, -118,    0,    0, -224, -234,    0,
    0,    0,    0,    0,  -13,    0,    0,    0, -224, -224,
    0,  -30, -104, -234,    0,  -23,  -23, -223,    2,    0,
    0,    0,    0, -222,    0,    0,  -17, -118, -224, -224,
    0,    0,    0,    0,    0,    0,    0, -224,    0,  -39,
    0,    0,    0,   -8,    0, -254,  -39,    0,   -5,    0,
    0, -224,    0,  -55,    0, -223,    0, -224,   -6,    0,
  -41,    0,    0,    0,    0,    0,    0,    0,
};
static const YYINT yyrindex[] = {                         1,
    0,    0,    0,    0,    0,    0,    0,  -69, -119,    0,
    0,    0,    0,    0,  -44,    0,    0,    0,  -67,  -32,
    0,  -33,    0,  -84,    0, -115, -115,  -11,  -57,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    5,    0,    0,  -22,    0,  -63,   16,    0,  -33,    0,
    0,    0,    0,    0,    0,  -11,    0,    0,    0,    0,
   -7,    0,    0,    0,    0,    0,    0,    0,
};
static const YYINT yygindex[] = {                         0,
    0,    0,   -1,    0,    0,    0,    0,   43,    0,    0,
   23,    0,    0,   46,   40,    0,    0,   15,   25,    0,
    0,    0,    0,   26,   29,    0,    0,    0,    0,    0,
    9,    0,    0,
};
#define YYTABLESIZE 283
static const YYINT yytable[] = {                         59,
    3,   21,   77,   54,    9,   13,   19,   17,   68,   17,
   29,   11,   12,   59,   59,    6,   59,   76,    7,   59,
   41,   30,   16,   17,   18,   29,   19,   39,    1,   34,
   40,   11,   12,   21,    2,   43,   30,   67,   54,   46,
   12,   11,   12,   52,   49,   48,   59,   26,   59,   62,
   14,   61,   39,    7,   40,   53,   57,   29,   38,   54,
   53,   35,   37,   32,   74,   21,   45,   21,   30,   42,
   63,   57,   72,   60,   20,   58,    0,    0,   59,   26,
   59,   54,   55,    0,    0,   57,    0,    0,    0,   29,
   59,   29,    0,    0,    0,   39,    0,    0,   59,    0,
   30,    0,   30,    0,   65,    0,   69,    0,    0,    0,
   75,   26,    0,   26,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   32,    0,   32,
    0,    0,    0,    0,    0,    0,    0,    0,   20,    0,
   20,   17,   17,   17,    0,   17,    0,    0,    0,    0,
   17,   17,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   21,
   21,   21,    0,   21,    0,   21,    0,    0,   21,   21,
   11,   12,   59,   59,   59,    0,   59,    0,   59,    0,
    0,   59,   59,   29,   29,   29,    0,   29,    0,   29,
    0,    0,   29,   29,   30,   30,   30,    0,   30,    0,
   30,    0,    0,   30,   30,   26,   26,   26,    0,   26,
    0,    0,    0,    0,   26,   26,    0,    9,   57,   57,
    9,   32,   32,   32,    0,   32,    0,    0,    0,    0,
   32,   32,   20,   20,   20,    0,   20,    0,    0,    0,
    0,   20,   20,
};
static const YYINT yycheck[] = {                         44,
    0,   59,   44,  123,  123,  125,  261,  123,   64,  125,
   44,  266,  267,   58,   59,  257,   61,   59,  260,   64,
  125,   44,  257,  258,  259,   59,  261,   58,  256,   43,
   61,  266,  267,   91,  262,   59,   59,   93,  123,  263,
  125,  266,  267,   61,  267,   44,   91,   59,   93,   58,
    8,   91,   58,  123,   61,  123,   64,   91,   91,  123,
   38,   19,   20,   59,   66,  123,   27,  125,   91,   24,
   56,   47,   64,   48,   59,   47,   -1,   -1,  123,   91,
  125,   39,   40,   -1,   -1,   93,   -1,   -1,   -1,  123,
   48,  125,   -1,   -1,   -1,   91,   -1,   -1,   56,   -1,
  123,   -1,  125,   -1,   62,   -1,   64,   -1,   -1,   -1,
   68,  123,   -1,  125,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,   -1,  125,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,   -1,
  125,  257,  258,  259,   -1,  261,   -1,   -1,   -1,   -1,
  266,  267,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
  258,  259,   -1,  261,   -1,  263,   -1,   -1,  266,  267,
  266,  267,  257,  258,  259,   -1,  261,   -1,  263,   -1,
   -1,  266,  267,  257,  258,  259,   -1,  261,   -1,  263,
   -1,   -1,  266,  267,  257,  258,  259,   -1,  261,   -1,
  263,   -1,   -1,  266,  267,  257,  258,  259,   -1,  261,
   -1,   -1,   -1,   -1,  266,  267,   -1,  257,  266,  267,
  260,  257,  258,  259,   -1,  261,   -1,   -1,   -1,   -1,
  266,  267,  257,  258,  259,   -1,  261,   -1,   -1,   -1,
   -1,  266,  267,
};
#define YYFINAL 3
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 267
#define YYUNDFTOKEN 303
#define YYTRANSLATE(a) ((a) > YYMAXTOKEN ? YYUNDFTOKEN : (a))
#if YYDEBUG
static const char *const yyname[] = {

"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,"'+'","','",0,0,0,0,0,0,0,0,0,0,0,0,0,"':'","';'",0,"'='",0,0,
"'@'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'['",0,"']'",0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'",0,"'}'",0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,"T_graph","T_node","T_edge","T_digraph","T_subgraph","T_strict",
"T_edgeop","T_list","T_attr","T_atom","T_qatom",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"illegal-symbol",
};
static const char *const yyrule[] = {
"$accept : graph",
"graph : hdr body",
"graph : error",
"graph :",
"body : '{' optstmtlist '}'",
"hdr : optstrict graphtype optgraphname",
"optgraphname : atom",
"optgraphname :",
"optstrict : T_strict",
"optstrict :",
"graphtype : T_graph",
"graphtype : T_digraph",
"optstmtlist : stmtlist",
"optstmtlist :",
"stmtlist : stmtlist stmt",
"stmtlist : stmt",
"optsemi : ';'",
"optsemi :",
"stmt : attrstmt optsemi",
"stmt : compound optsemi",
"compound : simple rcompound optattr",
"simple : nodelist",
"simple : subgraph",
"$$1 :",
"$$2 :",
"rcompound : T_edgeop $$1 simple $$2 rcompound",
"rcompound :",
"nodelist : node",
"nodelist : nodelist ',' node",
"node : atom",
"node : atom ':' atom",
"node : atom ':' atom ':' atom",
"attrstmt : attrtype optmacroname attrlist",
"attrstmt : graphattrdefs",
"attrtype : T_graph",
"attrtype : T_node",
"attrtype : T_edge",
"optmacroname : atom '='",
"optmacroname :",
"optattr : attrlist",
"optattr :",
"attrlist : optattr '[' optattrdefs ']'",
"optattrdefs : optattrdefs attrdefs",
"optattrdefs :",
"attrdefs : attritem optseparator",
"attritem : attrassignment",
"attritem : attrmacro",
"attrassignment : atom '=' atom",
"attrmacro : '@' atom",
"graphattrdefs : attrassignment",
"$$3 :",
"subgraph : optsubghdr $$3 body",
"optsubghdr : T_subgraph atom",
"optsubghdr : T_subgraph",
"optsubghdr :",
"optseparator : ';'",
"optseparator : ','",
"optseparator :",
"atom : T_atom",
"atom : qatom",
"qatom : T_qatom",
"qatom : qatom '+' T_qatom",

};
#endif

#if YYDEBUG
int      yydebug;
#endif

int      yyerrflag;
int      yychar;
YYSTYPE  yyval;
YYSTYPE  yylval;
int      yynerrs;

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH  10000
#endif
#endif

#define YYINITSTACKSIZE 200

typedef struct {
    unsigned stacksize;
    YYINT    *s_base;
    YYINT    *s_mark;
    YYINT    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
} YYSTACKDATA;
/* variables for the parser stack */
static YYSTACKDATA yystack;
#line 195 "../../lib/cgraph/grammar.y"

#define NILitem  NIL(item*)


static item *newitem(int tag, void *p0, char *p1)
{
	item	*rv = agalloc(G,sizeof(item));
	rv->tag = tag; rv->u.name = (char*)p0; rv->str = p1;
	return rv;
}

static item *cons_node(Agnode_t *n, char *port)
	{ return newitem(T_node,n,port); }

static item *cons_attr(char *name, char *value)
	{ return newitem(T_atom,name,value); }

static item *cons_list(item *list)
	{ return newitem(T_list,list,NIL(char*)); }

static item *cons_subg(Agraph_t *subg)
	{ return newitem(T_subgraph,subg,NIL(char*)); }

static gstack_t *push(gstack_t *s, Agraph_t *subg) {
	gstack_t *rv;
	rv = agalloc(G,sizeof(gstack_t));
	rv->down = s;
	rv->g = subg;
	return rv;
}

static gstack_t *pop(gstack_t *s)
{
	gstack_t *rv;
	rv = S->down;
	agfree(G,s);
	return rv;
}

#ifdef NOTDEF
static item *cons_edge(Agedge_t *e)
	{ return newitem(T_edge,e,NIL(char*)); }
#endif

static void delete_items(item *ilist)
{
	item	*p,*pn;

	for (p = ilist; p; p = pn) {
		pn = p->next;
		switch(p->tag) {
			case T_list: delete_items(p->u.list); break;
			case T_atom: case T_attr: agstrfree(G,p->str); break;
		}
		agfree(G,p);
	}
}

#ifdef NOTDEF
static void initlist(list_t *list)
{
	list->first = list->last = NILitem;
}
#endif

static void deletelist(list_t *list)
{
	delete_items(list->first);
	list->first = list->last = NILitem;
}

#ifdef NOTDEF
static void listins(list_t *list, item *v)
{
	v->next = list->first;
	list->first = v;
	if (list->last == NILitem) list->last = v;
}
#endif

static void listapp(list_t *list, item *v)
{
	if (list->last) list->last->next = v;
	list->last = v;
	if (list->first == NILitem) list->first = v;
}


/* attrs */
static void appendattr(char *name, char *value)
{
	item		*v;

	assert(value != NIL(char*));
	v = cons_attr(name,value);
	listapp(&(S->attrlist),v);
}

static void bindattrs(int kind)
{
	item		*aptr;
	char		*name;

	for (aptr = S->attrlist.first; aptr; aptr = aptr->next) {
		assert(aptr->tag == T_atom);	/* signifies unbound attr */
		name = aptr->u.name;
		if ((kind == AGEDGE) && streq(name,Key)) continue;
		if ((aptr->u.asym = agattr(S->g,kind,name,NIL(char*))) == NILsym)
			aptr->u.asym = agattr(S->g,kind,name,"");
		aptr->tag = T_attr;				/* signifies bound attr */
		agstrfree(G,name);
	}
}

/* attach node/edge specific attributes */
static void applyattrs(void *obj)
{
	item		*aptr;

	for (aptr = S->attrlist.first; aptr; aptr = aptr->next) {
		if (aptr->tag == T_attr) {
			if (aptr->u.asym) {
				agxset(obj,aptr->u.asym,aptr->str);
			}
		}
		else {
			/* assert(AGTYPE(obj) == AGEDGE);  surprising this fails */
			assert((AGTYPE(obj) == AGINEDGE) || (AGTYPE(obj) == AGOUTEDGE));
			assert(aptr->tag == T_atom);
			assert(streq(aptr->u.name,Key));
		}
	}
}

static void nomacros(void)
{
	agerr(AGWARN,"attribute macros not implemented");
}

/* attrstmt:
 * First argument is always attrtype, so switch covers all cases.
 * This function is used to handle default attribute value assignment.
 */
static void attrstmt(int tkind, char *macroname)
{
	item			*aptr;
	int				kind = 0;
	Agsym_t*  sym;

		/* creating a macro def */
	if (macroname) nomacros();
		/* invoking a macro def */
	for (aptr = S->attrlist.first; aptr; aptr = aptr->next)
		if (aptr->str == NIL(char*)) nomacros();

	switch(tkind) {
		case T_graph: kind = AGRAPH; break;
		case T_node: kind = AGNODE; break;
		case T_edge: kind = AGEDGE; break;
	}
	bindattrs(kind);	/* set up defaults for new attributes */
	for (aptr = S->attrlist.first; aptr; aptr = aptr->next) {
		/* If the tag is still T_atom, aptr->u.asym has not been set */
		if (aptr->tag == T_atom) continue;
		if (!(aptr->u.asym->fixed) || (S->g != G))
			sym = agattr(S->g,kind,aptr->u.asym->name,aptr->str);
		else
			sym = aptr->u.asym;
		if (S->g == G)
			sym->print = TRUE;
	}
	deletelist(&(S->attrlist));
}

/* nodes */

static void appendnode(char *name, char *port, char *sport)
{
	item		*elt;

	if (sport) {
		port = concatPort (port, sport);
	}
	elt = cons_node(agnode(S->g,name,TRUE),port);
	listapp(&(S->nodelist),elt);
	agstrfree(G,name);
}

/* apply current optional attrs to nodelist and clean up lists */
/* what's bad is that this could also be endsubg.  also, you can't
clean up S->subg in closesubg() because S->subg might be needed
to construct edges.  these are the sort of notes you write to yourself
in the future. */
static void endnode()
{
	item	*ptr;

	bindattrs(AGNODE);
	for (ptr = S->nodelist.first; ptr; ptr = ptr->next)
		applyattrs(ptr->u.n);
	deletelist(&(S->nodelist));
	deletelist(&(S->attrlist));
	deletelist(&(S->edgelist));
	S->subg = 0;  /* notice a pattern here? :-( */
}

/* edges - store up node/subg lists until optional edge key can be seen */

static void getedgeitems(int x)
{
	item	*v = 0;

	if (S->nodelist.first) {
		v = cons_list(S->nodelist.first);
		S->nodelist.first = S->nodelist.last = NILitem;
	}
	else {if (S->subg) v = cons_subg(S->subg); S->subg = 0;}
	/* else nil append */
	if (v) listapp(&(S->edgelist),v);
}

static void endedge(void)
{
	char			*key;
	item			*aptr,*tptr,*p;

	Agnode_t		*t;
	Agraph_t		*subg;

	bindattrs(AGEDGE);

	/* look for "key" pseudo-attribute */
	key = NIL(char*);
	for (aptr = S->attrlist.first; aptr; aptr = aptr->next) {
		if ((aptr->tag == T_atom) && streq(aptr->u.name,Key))
			key = aptr->str;
	}

	/* can make edges with node lists or subgraphs */
	for (p = S->edgelist.first; p->next; p = p->next) {
		if (p->tag == T_subgraph) {
			subg = p->u.subg;
			for (t = agfstnode(subg); t; t = agnxtnode(subg,t))
				edgerhs(agsubnode(S->g,t,FALSE),NIL(char*),p->next,key);
		}
		else {
			for (tptr = p->u.list; tptr; tptr = tptr->next)
				edgerhs(tptr->u.n,tptr->str,p->next,key);
		}
	}
	deletelist(&(S->nodelist));
	deletelist(&(S->edgelist));
	deletelist(&(S->attrlist));
	S->subg = 0;
}

/* concat:
 */
static char*
concat (char* s1, char* s2)
{
  char*  s;
  char   buf[BUFSIZ];
  char*  sym;
  size_t len = strlen(s1) + strlen(s2) + 1;

  if (len <= BUFSIZ) sym = buf;
  else sym = (char*)malloc(len);
  strcpy(sym,s1);
  strcat(sym,s2);
  s = agstrdup (G,sym);
  agstrfree (G,s1);
  agstrfree (G,s2);
  if (sym != buf) free (sym);
  return s;
}

/* concatPort:
 */
static char*
concatPort (char* s1, char* s2)
{
  char*  s;
  char   buf[BUFSIZ];
  char*  sym;
  size_t len = strlen(s1) + strlen(s2) + 2;  /* one more for ':' */

  if (len <= BUFSIZ) sym = buf;
  else sym = (char*)malloc(len);
  sprintf (sym, "%s:%s", s1, s2);
  s = agstrdup (G,sym);
  agstrfree (G,s1);
  agstrfree (G,s2);
  if (sym != buf) free (sym);
  return s;
}


static void edgerhs(Agnode_t *tail, char *tport, item *hlist, char *key)
{
	Agnode_t		*head;
	Agraph_t		*subg;
	item			*hptr;

	if (hlist->tag == T_subgraph) {
		subg = hlist->u.subg;
		for (head = agfstnode(subg); head; head = agnxtnode(subg,head))
			newedge(tail,tport,agsubnode(S->g,head,FALSE),NIL(char*),key);
	}
	else {
		for (hptr = hlist->u.list; hptr; hptr = hptr->next)
			newedge(tail,tport,agsubnode(S->g,hptr->u.n,FALSE),hptr->str,key);
	}
}

static void mkport(Agedge_t *e, char *name, char *val)
{
	Agsym_t *attr;
	if (val) {
		if ((attr = agattr(S->g,AGEDGE,name,NIL(char*))) == NILsym)
			attr = agattr(S->g,AGEDGE,name,"");
		agxset(e,attr,val);
	}
}

static void newedge(Agnode_t *t, char *tport, Agnode_t *h, char *hport, char *key)
{
	Agedge_t 	*e;

	e = agedge(S->g,t,h,key,TRUE);
	if (e) {		/* can fail if graph is strict and t==h */
		char    *tp = tport;
		char    *hp = hport;
		if ((agtail(e) != aghead(e)) && (aghead(e) == t)) {
			/* could happen with an undirected edge */
			char    *temp;
			temp = tp; tp = hp; hp = temp;
		}
		mkport(e,TAILPORT_ID,tp);
		mkport(e,HEADPORT_ID,hp);
		applyattrs(e);
	}
}

/* graphs and subgraphs */


static void startgraph(char *name, int directed, int strict)
{
	static Agdesc_t	req;	/* get rid of warnings */

	if (G == NILgraph) {
    SubgraphDepth = 0;
		req.directed = directed;
		req.strict = strict;
		req.maingraph = TRUE;
		Ag_G_global = G = agopen(name,req,Disc);
	}
	else {
		Ag_G_global = G;
	}
	S = push(S,G);
	agstrfree(NIL(Agraph_t*),name);
}

static void endgraph()
{
	aglexeof();
	aginternalmapclearlocalnames(G);
}

static void opensubg(char *name)
{
  if (++SubgraphDepth >= YYMAXDEPTH/2) {
    char buf[128];
    sprintf(buf,"subgraphs nested more than %d deep",YYMAXDEPTH);
    agerr(AGERR,buf);
  }
	S = push(S,agsubg(S->g,name,TRUE));
	agstrfree(G,name);
}

static void closesubg()
{
	Agraph_t *subg = S->g;
  --SubgraphDepth;
	S = pop(S);
	S->subg = subg;
	assert(subg);
}

static void freestack()
{
	while (S) {
		deletelist(&(S->nodelist));
		deletelist(&(S->attrlist));
		deletelist(&(S->edgelist));
		S = pop(S);
	}
}

extern FILE *yyin;
Agraph_t *agconcat(Agraph_t *g, void *chan, Agdisc_t *disc)
{
	yyin = chan;
	G = g;
	Ag_G_global = NILgraph;
	Disc = (disc? disc :  &AgDefaultDisc);
	aglexinit(Disc, chan);
	yyparse();
	if (Ag_G_global == NILgraph) aglexbad();
	return Ag_G_global;
}

Agraph_t *agread(void *fp, Agdisc_t *disc) {return agconcat(NILgraph,fp,disc); }

#line 813 "y.tab.c"

#if YYDEBUG
#include <stdio.h>	/* needed for printf */
#endif

#include <stdlib.h>	/* needed for malloc, etc */
#include <string.h>	/* needed for memset */

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    YYINT *newss;
    YYSTYPE *newvs;

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return YYENOMEM;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = (int) (data->s_mark - data->s_base);
    newss = (YYINT *)realloc(data->s_base, newsize * sizeof(*newss));
    if (newss == 0)
        return YYENOMEM;

    data->s_base = newss;
    data->s_mark = newss + i;

    newvs = (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs));
    if (newvs == 0)
        return YYENOMEM;

    data->l_base = newvs;
    data->l_mark = newvs + i;

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab

int
YYPARSE_DECL()
{
    int yym, yyn, yystate;
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yym = 0;
    yyn = 0;
    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        yychar = YYLEX;
        if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if (((yyn = yysindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if (((yyn = yyrindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag != 0) goto yyinrecovery;

    YYERROR_CALL("syntax error");

    goto yyerrlab; /* redundant goto avoids 'unused label' warning */
yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if (((yyn = yysindex[*yystack.s_mark]) != 0) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
                --yystack.s_mark;
                --yystack.l_mark;
            }
        }
    }
    else
    {
        if (yychar == YYEOF) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym > 0)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);

    switch (yyn)
    {
case 1:
#line 99 "../../lib/cgraph/grammar.y"
	{freestack(); endgraph();}
break;
case 2:
#line 100 "../../lib/cgraph/grammar.y"
	{if (G) {freestack(); endgraph(); agclose(G); G = Ag_G_global = NIL(Agraph_t*);}}
break;
case 5:
#line 106 "../../lib/cgraph/grammar.y"
	{startgraph(yystack.l_mark[0].str,yystack.l_mark[-1].i,yystack.l_mark[-2].i);}
break;
case 6:
#line 109 "../../lib/cgraph/grammar.y"
	{yyval.str=yystack.l_mark[0].str;}
break;
case 7:
#line 109 "../../lib/cgraph/grammar.y"
	{yyval.str=0;}
break;
case 8:
#line 111 "../../lib/cgraph/grammar.y"
	{yyval.i=1;}
break;
case 9:
#line 111 "../../lib/cgraph/grammar.y"
	{yyval.i=0;}
break;
case 10:
#line 113 "../../lib/cgraph/grammar.y"
	{yyval.i = 0;}
break;
case 11:
#line 113 "../../lib/cgraph/grammar.y"
	{yyval.i = 1;}
break;
case 20:
#line 126 "../../lib/cgraph/grammar.y"
	{if (yystack.l_mark[-1].i) endedge(); else endnode();}
break;
case 23:
#line 131 "../../lib/cgraph/grammar.y"
	{getedgeitems(1);}
break;
case 24:
#line 131 "../../lib/cgraph/grammar.y"
	{getedgeitems(2);}
break;
case 25:
#line 131 "../../lib/cgraph/grammar.y"
	{yyval.i = 1;}
break;
case 26:
#line 132 "../../lib/cgraph/grammar.y"
	{yyval.i = 0;}
break;
case 29:
#line 138 "../../lib/cgraph/grammar.y"
	{appendnode(yystack.l_mark[0].str,NIL(char*),NIL(char*));}
break;
case 30:
#line 139 "../../lib/cgraph/grammar.y"
	{appendnode(yystack.l_mark[-2].str,yystack.l_mark[0].str,NIL(char*));}
break;
case 31:
#line 140 "../../lib/cgraph/grammar.y"
	{appendnode(yystack.l_mark[-4].str,yystack.l_mark[-2].str,yystack.l_mark[0].str);}
break;
case 32:
#line 143 "../../lib/cgraph/grammar.y"
	{attrstmt(yystack.l_mark[-2].i,yystack.l_mark[-1].str);}
break;
case 33:
#line 144 "../../lib/cgraph/grammar.y"
	{attrstmt(T_graph,NIL(char*));}
break;
case 34:
#line 147 "../../lib/cgraph/grammar.y"
	{yyval.i = T_graph;}
break;
case 35:
#line 148 "../../lib/cgraph/grammar.y"
	{yyval.i = T_node;}
break;
case 36:
#line 149 "../../lib/cgraph/grammar.y"
	{yyval.i = T_edge;}
break;
case 37:
#line 152 "../../lib/cgraph/grammar.y"
	{yyval.str = yystack.l_mark[-1].str;}
break;
case 38:
#line 153 "../../lib/cgraph/grammar.y"
	{yyval.str = NIL(char*); }
break;
case 47:
#line 168 "../../lib/cgraph/grammar.y"
	{appendattr(yystack.l_mark[-2].str,yystack.l_mark[0].str);}
break;
case 48:
#line 171 "../../lib/cgraph/grammar.y"
	{appendattr(yystack.l_mark[0].str,NIL(char*));}
break;
case 50:
#line 177 "../../lib/cgraph/grammar.y"
	{opensubg(yystack.l_mark[0].str);}
break;
case 51:
#line 177 "../../lib/cgraph/grammar.y"
	{closesubg();}
break;
case 52:
#line 180 "../../lib/cgraph/grammar.y"
	{yyval.str=yystack.l_mark[0].str;}
break;
case 53:
#line 181 "../../lib/cgraph/grammar.y"
	{yyval.str=NIL(char*);}
break;
case 54:
#line 182 "../../lib/cgraph/grammar.y"
	{yyval.str=NIL(char*);}
break;
case 58:
#line 187 "../../lib/cgraph/grammar.y"
	{yyval.str = yystack.l_mark[0].str;}
break;
case 59:
#line 188 "../../lib/cgraph/grammar.y"
	{yyval.str = yystack.l_mark[0].str;}
break;
case 60:
#line 191 "../../lib/cgraph/grammar.y"
	{yyval.str = yystack.l_mark[0].str;}
break;
case 61:
#line 192 "../../lib/cgraph/grammar.y"
	{yyval.str = concat(yystack.l_mark[-2].str,yystack.l_mark[0].str);}
break;
#line 1152 "y.tab.c"
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
        if (yychar < 0)
        {
            yychar = YYLEX;
            if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
            if (yydebug)
            {
                if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == YYEOF) goto yyaccept;
        goto yyloop;
    }
    if (((yyn = yygindex[yym]) != 0) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yystack.s_mark, yystate);
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    *++yystack.s_mark = (YYINT) yystate;
    *++yystack.l_mark = yyval;
    goto yyloop;

yyoverflow:
    YYERROR_CALL("yacc stack overflow");

yyabort:
    yyfreestack(&yystack);
    return (1);

yyaccept:
    yyfreestack(&yystack);
    return (0);
}
